<template>
  <div
    class="flex flex-col gap-4"
    :class="cardSize === 'default' ? 'w-full' : 'w-full max-w-[294px]'"
  >
    <div
      v-if="feedback"
      class="w-full flex flex-col gap-[10px]"
    >
      <svn-pro-title
        medium
        :h6="cardSize !== 'default'"
        :h5="cardSize === 'default'"
      >
        {{ feedbackTitle }}
      </svn-pro-title>

      <svn-pro-text
        regular
        subtitle-large
        color="onSurfaceVariant"
      >
        {{ feedbackDescription }}
      </svn-pro-text>
    </div>

    <v-list
      select-strategy="classic"
      class="w-full flex flex-col !py-0"
      :class="cardSize === 'default' ? 'gap-4' : 'gap-2'"
    >
      <v-list-item
        v-for="reaction in reactions"
        :value="reaction?.value"
        color="primary"
        class="!px-0 !py-0 !rounded-[8px]"
        :active="false"
      >
        <div
          variant="flat"
          class="w-full border border-borderColor border-opacity-100 bg-surfaceBright rounded-[8px] flex items-center px-2 py-4 gap-4"
          @click="toggleReaction(reaction?.value)"
        >
          <v-checkbox-btn
            color="primary"
            :model-value="reaction?.active"
          />

          <div class="w-full flex items-center gap-4">
            <div class="w-12 h-12 flex justify-center items-center self-center">
              <iframe
                :src="reaction?.icon"
                :width="48"
                :height="48"
              />
            </div>

            <svn-pro-text subtitle-large medium :color="reaction?.active ? 'primary' : 'onSurfaceVariant'">
              {{ reaction?.text }}
            </svn-pro-text>
          </div>
        </div>
      </v-list-item>
    </v-list>
  </div>
</template>

<script setup>
import SvnProText from '../styles/SvnProText.vue';
import SvnProTitle from '../styles/SvnProTitle.vue';

const props = defineProps({
  feedback: {
    type: Boolean,
    default: false,
  },
  cardSize: {
    type: String,
    default: "default",
  },
  reactions: {
    type: Array,
    default: () => [],
  },
  feedbackTitle: {
    type: String,
    default: "What did you think of the module?",
  },
  feedbackDescription: {
    type: String,
    default: "Your feedback helps us improve this module.",
  },
})

const emit = defineEmits(['toggle-reaction']);

const toggleReaction = (reactionType) => {
  emit('toggle-reaction', reactionType)
}
</script>